#include <sys/types.h>
#include <string.h>

#include "dynarr.h"

/*
 *  Last touched 1994-03-11?
 *  Looks like this code is subject to buffer overflow
 *  if a word is >sizeof(Buf)
 *
 *  S[] consists of fields separated by runs of characters from Sep[].
 *  S[] is split into fields, and a pointer to each is put into an array.
 *  The array is terminated with a null pointer.
 *  A pointer to the array is returned.
 *  Characters in Sep[] are not separators if preceded by EscChar.
 */
char **StrToArr(S,Sep,EscChar)
char *S;
char Sep[];
char EscChar;
{
    struct AllocArr Arr;
    char *Dest;
    char Buf[256];
    int InEsc = 0;
    char C;

    InitArrRec(Arr,char *,10,10);
    Dest = Buf;
    for (C = *S; C; C = *++S) {
	if (InEsc) {
	    InEsc = 0;
	    *(Dest++) = C;
	}
	else if (C == EscChar)
	    InEsc = 1;
	else if (strchr(Sep,C)) {
	    if (Dest != Buf) {
		*Dest = '\0';
		Dest = Buf;
		AddElem(Arr,strdup(Buf),char *);
	    }
	}
	else
	    *(Dest++) = C;
    }
    if (Dest != Buf) {
	*Dest = '\0';
	AddElem(Arr,strdup(Buf),char *);
    }
    AddElem(Arr,(char *) 0,char *);
    return((char **) ArrPt(Arr));
}
