/*
 * For Linux.  This makes the exit status structure elements be 
 * e_termination and e_exit instead of __e_termination and __e_exit.
 */
#define __USE_GNU

#include <utmp.h>

#ifdef UT_HOSTSIZE
#define UTMP_IS_UTMPX
#endif

#if defined(EXTENDED) || defined(UTMP_IS_UTMPX)
#   include <utmpx.h>
#endif

#ifdef UTMP_IS_UTMPX
#undef EXTENDED
#endif

void *n_getutent(long NumSkip);
int utmpConfig(int Verify, void *Arg);
void n_utmpname(char *Name);
void utmpxPrint(FILE *f, struct utmpx *u, int verbose, char *time_format, int printExt);
struct utmpx *u2ux(struct utmp *u);


extern off_t search_skipped;
extern long utmp_bytes_read;
extern int n_getutent_err;

#define UTMP_VERIFY 1
#define UTMP_NOSIZECHECK 2
#define UTMP_AUTOVERIFY 3
#define UTMP_VERBOSE 4
#define UTMP_PROGRESS 5
/* If a bad section is skipped, return a utmp entry with type set to -1
and the global search_skipped set to the number of bytes skipped */
#define UTMP_RET_BAD 6
#define UTMP_EXTENDED 7
#define UTMP_REG 8
#define UTMP_NAME 9
#define UTMP_FD 10
#define UTMP_AUTOSENSE 11
#define UTMP_TYPE 12
#define UTMP_BAD (-1)

#define NUTMP_FAIL_OPEN 1
#define NUTMP_FAIL_READ 2
#define NUTMP_FAIL_AUTO 3
#define NUTMP_FAIL_TYPE 4
#define NUTMP_FAIL_SIZE 5
#define NUTMP_FAIL_EMPTY 6

/* Defined under SYSV */
#ifndef	UTMAXTYPE
#define	UTMAXTYPE	ACCOUNTING
#endif
